package be.iminds.ilabt.jfed.experimenter_gui.controller.model;

import be.iminds.ilabt.jfed.experimenter_gui.controller.model.ControllerModel.CommandEditorMode;
import be.iminds.ilabt.jfed.experimenter_gui.controller.view.ControllerNodeFactory;
import be.iminds.ilabt.jfed.experimenter_gui.editor.ModelRspecEditor;
import be.iminds.ilabt.jfed.experimenter_gui.util.ProxyServiceUtil;
import be.iminds.ilabt.jfed.highlevel.util.ProxySocketFactoryProvider;
import be.iminds.ilabt.jfed.lowlevel.GeniUserProvider;
import be.iminds.ilabt.jfed.rspec.model.javafx_impl.FXModelRspec;

import javax.inject.Inject;
import javax.inject.Singleton;

/**
 * User: twalcari
 * Date: 12/8/2014
 * Time: 17:12
 */
@Singleton
public class ControllerModelFactory {

    private final GeniUserProvider geniUserProvider;
    private final ProxySocketFactoryProvider proxySocketFactoryProvider;
    private final ProxyServiceUtil proxyServiceUtil;
    private final ControllerNodeFactory controllerNodeFactory;

    @Inject
    public ControllerModelFactory(GeniUserProvider geniUserProvider, ProxySocketFactoryProvider proxySocketFactoryProvider,
                                  ProxyServiceUtil proxyServiceUtil, ControllerNodeFactory controllerNodeFactory) {
        this.geniUserProvider = geniUserProvider;
        this.proxySocketFactoryProvider = proxySocketFactoryProvider;
        this.proxyServiceUtil = proxyServiceUtil;
        this.controllerNodeFactory = controllerNodeFactory;
    }

    public ControllerModel createControllerModel(FXModelRspec requestModelRspec, CommandEditorMode editorMode) {
        return new ControllerModel(requestModelRspec, editorMode, geniUserProvider, proxySocketFactoryProvider, proxyServiceUtil, controllerNodeFactory);
    }

    public ControllerModel createControllerModel(ModelRspecEditor modelRspecEditor, CommandEditorMode editorMode) {
        return new ControllerModel(modelRspecEditor, editorMode, geniUserProvider, proxySocketFactoryProvider, proxyServiceUtil, controllerNodeFactory);
    }
}