package be.iminds.ilabt.jfed.experimenter_gui.editor.addresspool_properties;

import be.iminds.ilabt.jfed.experimenter_gui.config.JFedGuiConfig;
import be.iminds.ilabt.jfed.experimenter_gui.editor.properties.cmi.GlobalCMIManager;
import be.iminds.ilabt.jfed.experimenter_gui.util.ui.FXUtils;
import be.iminds.ilabt.jfed.experimenter_gui.util.ui.StageUtils;

import be.iminds.ilabt.jfed.lowlevel.TestbedInfoSource;
import be.iminds.ilabt.jfed.rspec.model.javafx_impl.FXAddressPool;
import be.iminds.ilabt.jfed.rspec.model.javafx_impl.FXModelRspec;
import javafx.scene.Scene;
import javafx.stage.Stage;
import javafx.stage.Window;

import javax.inject.Inject;
import javax.inject.Singleton;

/**
 * User: twalcari
 * Date: 12/2/2014
 * Time: 14:45
 */
@Singleton
public class AddressPoolPropertiesDialogFactory {

    private final JFedGuiConfig config;
    private final TestbedInfoSource testbedInfoSource;
    private final GlobalCMIManager cmiManager;

    @Inject
    public AddressPoolPropertiesDialogFactory(TestbedInfoSource testbedInfoSource, JFedGuiConfig config, GlobalCMIManager cmiManager) {
        this.testbedInfoSource = testbedInfoSource;
        this.config = config;
        this.cmiManager = cmiManager;
    }

    public AddressPoolPropertiesDialog createChannelPropertiesDialog(FXAddressPool addressPool, FXModelRspec modelRspec) {
        return new AddressPoolPropertiesDialog(addressPool, modelRspec, config, testbedInfoSource, cmiManager);
    }

    public boolean showAddressPoolPropertiesDialog(Window parent, FXAddressPool addressPool, FXModelRspec modelRspec) {
        final AddressPoolPropertiesDialog addressPoolPropertiesDialog = createChannelPropertiesDialog(addressPool, modelRspec);
        Scene scene = new Scene(addressPoolPropertiesDialog);

        Stage dialogStage = new Stage();
        StageUtils.setJFedStageIcons(dialogStage);
        dialogStage.setScene(scene);


        dialogStage.setTitle("Address Pool properties");
        FXUtils.centerToOwner(parent, dialogStage);

        dialogStage.showAndWait();

        return addressPoolPropertiesDialog.isSuccess();

    }
}
