package be.iminds.ilabt.jfed.lowlevel.ssh_key_info;

import javax.annotation.Nullable;
import java.security.PrivateKey;
import java.security.PublicKey;

/**
 * Ssh Key info. This offers access to various info needed for SSH.
 * Sometimes, this might require making temporary files.
 *
 * Call release() to delete any temporary files containing unencrypted private keys
 * */
public interface SshKeyInfo {


    /** Does this SSH key info have access to the unencrypted private key? */
    boolean hasUnencryptedPrivateKey();

    /** may be null */
    @Nullable
    PublicKey getPublicKey();
    /** may be null */
    @Nullable
    PrivateKey getPrivateKey();
}